// This is originally from kmacs sw by C. Leimeister
// Modified by C.Pizzi 26/05/2016

#include "parser.h"

int parse(FILE *stream, vector<string>& taxa, vector<string>& sequences){
	vector<char> seqBuffer;
	vector<char> taxaBuffer;
	char c=getc(stream);
	int bufSize;
	while(c!=EOF){
		if(c=='>'){
			while((c=getc(stream))!='\n'){
				taxaBuffer.push_back(c);  
			}
		}
		else if(c==';')
			while((c=getc(stream))!='\n');
		else{
			while((c=getc(stream))!='>' && c!=EOF){
				if(!isalpha(c)){
					continue;
				}
				c=toupper(c);

				if(c == 'A' || c == 'C' || c == 'G' || c == 'T')
				  seqBuffer.push_back(c);	
				else seqBuffer.push_back('N');
				
			}	
		}
		bufSize = seqBuffer.size();
		if(bufSize>0){
			string taxaString(taxaBuffer.begin(),taxaBuffer.end());
			string seqString(seqBuffer.begin(),seqBuffer.end());
			cout<<"size = "<<bufSize<<endl;
		        
			taxa.push_back(taxaString);
			sequences.push_back(seqString);
			seqBuffer.clear();
			taxaBuffer.clear();
		}
	}
	return FASTA_OK;
}

int writeDmat(double** DMat, vector<string>& taxa, int mode, int k){
	string filename;
	if(mode==1)
	  filename = "kacs-k"+to_string(k);
	else
	  filename = "kmcs-k"+to_string(k);
	ofstream outfile(filename);
	int txsize = taxa.size();
	outfile << txsize <<endl;
		for(int i=0;i<txsize;i++){
			outfile << left << setw(10) << taxa.at(i).substr(0,10)<<"\t";
				for(int j=0;j<txsize;j++){
					if(i!=j){
						outfile << setprecision(8) << DMat[i][j] << "  ";
						}
					else
						outfile << setprecision(8) << "0" << "  ";
				}
			outfile << endl;
		}
	outfile.close();
	return FASTA_OK;
}
